diff --git a/game/client/src/main/java/net/minecraft/client/render/camera/EntityCameraSleeping.java b/game/client/src/main/java/net/minecraft/client/render/camera/EntityCameraSleeping.java
index ebea638d5..db3e1271e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/camera/EntityCameraSleeping.java
+++ b/game/client/src/main/java/net/minecraft/client/render/camera/EntityCameraSleeping.java
@@ -2,10 +2,11 @@ package net.minecraft.client.render.camera;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.core.entity.Mob;
+import net.minecraft.core.world.pos.TilePos;
+import org.jetbrains.annotations.NotNull;
 
 public class EntityCameraSleeping
-    extends EntityCamera
-{
+    extends EntityCamera {
     private static final int ANIM_TICKS = 5;
     private int ticks = 0;
 
@@ -30,25 +31,20 @@ public class EntityCameraSleeping
     private final double xRotS;
     private final double xRotT;
 
-    public EntityCameraSleeping(Minecraft mc, Mob entity, int xb, int yb, int zb, double xs, double ys, double zs, double yRotS, double xRotS)
-    {
+    public EntityCameraSleeping(@NotNull Minecraft mc, @NotNull Mob entity, int xb, int yb, int zb, double xs, double ys, double zs, double yRotS, double xRotS) {
         super(mc, entity);
-        int metadata = mc.currentWorld.getBlockMetadata(xb, yb, zb) & 3;
+        int metadata = mc.currentWorld.getBlockData(new TilePos(xb, yb, zb)) & 3;
 
-        while (yRotS < 0)
-        {
+        while (yRotS < 0) {
             yRotS += 360;
         }
-        while (yRotS > 360)
-        {
+        while (yRotS > 360) {
             yRotS -= 360;
         }
-        while (xRotS < 0)
-        {
+        while (xRotS < 0) {
             xRotS += 360;
         }
-        while (xRotS > 360)
-        {
+        while (xRotS > 360) {
             xRotS -= 360;
         }
 
@@ -65,17 +61,15 @@ public class EntityCameraSleeping
     }
 
     @Override
-    public void tick()
-    {
+    public void tick() {
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
         this.yRotO = this.yRot;
         this.xRotO = this.xRot;
-        if (ticks < ANIM_TICKS)
-        {
-            ticks++;
-            double progress = (double)ticks / ANIM_TICKS;
+        if (this.ticks < ANIM_TICKS) {
+            this.ticks++;
+            double progress = (double) this.ticks / ANIM_TICKS;
             double dx = this.xt - this.xs;
             double dy = this.yt - this.ys;
             double dz = this.zt - this.zs;
@@ -92,67 +86,47 @@ public class EntityCameraSleeping
     }
 
     @Override
-    public double getX(float partialTick)
-    {
-        if (partialTick == 1f || mob.isRemoved())
-        {
-            return x;
-        }
-        else
-        {
-            return xo + (x - xo) * partialTick;
+    public double getX(float partialTick) {
+        if (partialTick == 1f || this.mob.isRemoved()) {
+            return this.x;
+        } else {
+            return this.xo + (this.x - this.xo) * partialTick;
         }
     }
 
     @Override
-    public double getY(float partialTick)
-    {
-        if (partialTick == 1f || mob.isRemoved())
-        {
-            return y;
-        }
-        else
-        {
-            return yo + (y - yo) * partialTick;
+    public double getY(float partialTick) {
+        if (partialTick == 1f || this.mob.isRemoved()) {
+            return this.y;
+        } else {
+            return this.yo + (this.y - this.yo) * partialTick;
         }
     }
 
     @Override
-    public double getZ(float partialTick)
-    {
-        if (partialTick == 1f || mob.isRemoved())
-        {
-            return z;
-        }
-        else
-        {
-            return zo + (z - zo) * partialTick;
+    public double getZ(float partialTick) {
+        if (partialTick == 1f || this.mob.isRemoved()) {
+            return this.z;
+        } else {
+            return this.zo + (this.z - this.zo) * partialTick;
         }
     }
 
     @Override
-    public double getXRot(float partialTick)
-    {
-        if (partialTick == 1f || mob.isRemoved())
-        {
-            return xRot;
-        }
-        else
-        {
-            return xRotO + (xRot - xRotO) * partialTick;
+    public double getXRot(float partialTick) {
+        if (partialTick == 1f || this.mob.isRemoved()) {
+            return this.xRot;
+        } else {
+            return this.xRotO + (this.xRot - this.xRotO) * partialTick;
         }
     }
 
     @Override
-    public double getYRot(float partialTick)
-    {
-        if (partialTick == 1f || mob.isRemoved())
-        {
-            return yRot;
-        }
-        else
-        {
-            return yRotO + (yRot - yRotO) * partialTick;
+    public double getYRot(float partialTick) {
+        if (partialTick == 1f || this.mob.isRemoved()) {
+            return this.yRot;
+        } else {
+            return this.yRotO + (this.yRot - this.yRotO) * partialTick;
         }
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/camera/EntityCameraThirdPersonFront.java b/game/client/src/main/java/net/minecraft/client/render/camera/EntityCameraThirdPersonFront.java
index 7b239fa47..4298b0783 100644
--- a/game/client/src/main/java/net/minecraft/client/render/camera/EntityCameraThirdPersonFront.java
+++ b/game/client/src/main/java/net/minecraft/client/render/camera/EntityCameraThirdPersonFront.java
@@ -2,24 +2,21 @@ package net.minecraft.client.render.camera;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.core.entity.Mob;
+import org.jetbrains.annotations.NotNull;
 
 public class EntityCameraThirdPersonFront
-        extends EntityCameraThirdPersonRear
-{
-    public EntityCameraThirdPersonFront(Minecraft mc, Mob entity)
-    {
+    extends EntityCameraThirdPersonRear {
+    public EntityCameraThirdPersonFront(@NotNull Minecraft mc, @NotNull Mob entity) {
         super(mc, entity);
     }
 
     @Override
-    public double getYRot(float partialTick)
-    {
+    public double getYRot(float partialTick) {
         return super.getYRot(partialTick) + 180;
     }
 
     @Override
-    public double getXRot(float partialTick)
-    {
+    public double getXRot(float partialTick) {
         return -super.getXRot(partialTick);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/camera/EntityCameraThirdPersonRear.java b/game/client/src/main/java/net/minecraft/client/render/camera/EntityCameraThirdPersonRear.java
index 4aa1ecb6e..ae0757a95 100644
--- a/game/client/src/main/java/net/minecraft/client/render/camera/EntityCameraThirdPersonRear.java
+++ b/game/client/src/main/java/net/minecraft/client/render/camera/EntityCameraThirdPersonRear.java
@@ -4,30 +4,27 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.phys.Vec3;
+import org.jetbrains.annotations.NotNull;
+import org.joml.Vector3d;
+import org.joml.Vector3dc;
 
 public class EntityCameraThirdPersonRear
-    extends EntityCamera
-{
+    extends EntityCamera {
     protected float lastpartialTick = 0f;
     protected double lastCameraDistance = 0d;
 
-    public EntityCameraThirdPersonRear(Minecraft mc, Mob entity)
-    {
+    public EntityCameraThirdPersonRear(@NotNull Minecraft mc, @NotNull Mob entity) {
         super(mc, entity);
     }
 
     @Override
-    public boolean showPlayer()
-    {
+    public boolean showPlayer() {
         return true;
     }
 
-    private double getCameraDistance(float partialTick)
-    {
-        if (partialTick == lastpartialTick)
-        {
-            return lastCameraDistance;
+    private double getCameraDistance(float partialTick) {
+        if (partialTick == this.lastpartialTick) {
+            return this.lastCameraDistance;
         }
 
         int numSteps = 5;
@@ -44,71 +41,65 @@ public class EntityCameraThirdPersonRear
         double dz = (MathHelper.cos((yRot / 180F) * MathHelper.PI) * MathHelper.cos((xRot / 180F) * MathHelper.PI));
         double dy = (-MathHelper.sin((xRot / 180F) * MathHelper.PI));
 
-        double cameraDistance = Vec3.fromPool(x, y, z).distanceTo(Vec3.fromPool(x - numSteps * dx, y - numSteps * dy, z - numSteps * dz)) - offset;
+        Vector3dc start = new Vector3d(x, y, z);
+        double cameraDistance = start.distance(x - numSteps * dx, y - numSteps * dy, z - numSteps * dz) - offset;
 
-        for(int i = 0; i <= numSteps; i++)
-        {
-            HitResult hitResult = mc.currentWorld.checkBlockCollisionBetweenPoints(
-                    Vec3.fromPool(x, y, z),
-                    Vec3.fromPool(x - i * dx, y - i * dy, z - i * dz),
-                    false,
-                    true,
+        for (int i = 0; i <= numSteps; i++) {
+            HitResult hitResult = this.mc.currentWorld.checkBlockCollisionBetweenPoints(
+                start,
+                new Vector3d(x - i * dx, y - i * dy, z - i * dz),
+                false,
+                true,
                 false);
-            if(hitResult != null)
-            {
-                double distance = hitResult.location.distanceTo(Vec3.fromPool(x, y, z)) - offset;
+            if (hitResult != null) {
+                double distance = hitResult.location.distance(x, y, z) - offset;
                 if (distance < 0) distance = 0;
                 cameraDistance = distance;
                 break;
             }
         }
 
-        lastpartialTick = partialTick;
-        lastCameraDistance = cameraDistance;
+        this.lastpartialTick = partialTick;
+        this.lastCameraDistance = cameraDistance;
         return cameraDistance;
     }
 
     @Override
-    public double getX(float partialTick)
-    {
+    public double getX(float partialTick) {
         float yRot = (float) (getYRot(partialTick));
         float xRot = (float) (getXRot(partialTick));
         double cameraDistance = getCameraDistance(partialTick);
-        double dx = (double)(-MathHelper.sin((yRot / 180F) * MathHelper.PI) * MathHelper.cos((xRot / 180F) * MathHelper.PI)) * cameraDistance;
+        double dx = (double) (-MathHelper.sin((yRot / 180F) * MathHelper.PI) * MathHelper.cos((xRot / 180F) * MathHelper.PI)) * cameraDistance;
 
         return super.getX(partialTick) - dx;
     }
 
     @Override
-    public double getY(float partialTick)
-    {
+    public double getY(float partialTick) {
         float xRot = (float) (getXRot(partialTick));
         double cameraDistance = getCameraDistance(partialTick);
-        double dy = (double)(-MathHelper.sin((xRot / 180F) * MathHelper.PI)) * cameraDistance;
+        double dy = (double) (-MathHelper.sin((xRot / 180F) * MathHelper.PI)) * cameraDistance;
 
         return super.getY(partialTick) - dy;
     }
 
     @Override
-    public double getZ(float partialTick)
-    {
+    public double getZ(float partialTick) {
         float yRot = (float) (getYRot(partialTick));
         float xRot = (float) (getXRot(partialTick));
         double cameraDistance = getCameraDistance(partialTick);
-        double dz = (double)(MathHelper.cos((yRot / 180F) * MathHelper.PI) * MathHelper.cos((xRot / 180F) * MathHelper.PI)) * cameraDistance;
+        double dz = (double) (MathHelper.cos((yRot / 180F) * MathHelper.PI) * MathHelper.cos((xRot / 180F) * MathHelper.PI)) * cameraDistance;
 
         return super.getZ(partialTick) - dz;
     }
 
     @Override
-    public double getYRot(float partialTick)
-    {
+    public double getYRot(float partialTick) {
         return super.getYRot(partialTick);
     }
 
     @Override
-    public double getXRot(float partialTick)
-    {
+    public double getXRot(float partialTick) {
         return super.getXRot(partialTick);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/camera/ICamera.java b/game/client/src/main/java/net/minecraft/client/render/camera/ICamera.java
index 97717663d..c0a2d0f45 100644
--- a/game/client/src/main/java/net/minecraft/client/render/camera/ICamera.java
+++ b/game/client/src/main/java/net/minecraft/client/render/camera/ICamera.java
@@ -3,10 +3,13 @@ package net.minecraft.client.render.camera;
 import net.minecraft.client.render.culling.CameraFrustum;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.phys.Vec3;
+import net.minecraft.core.world.pos.TilePos;
+import org.jetbrains.annotations.NotNull;
+import org.joml.Math;
+import org.joml.Vector3d;
+import org.joml.Vector3dc;
 
-public interface ICamera
-{
+public interface ICamera {
     void tick();
 
     void applyGlTransformations();
@@ -15,113 +18,93 @@ public interface ICamera
 
     double getX(float partialTick);
 
-    default double getX()
-    {
+    default double getX() {
         return getX(1f);
     }
 
     double getY(float partialTick);
 
-    default double getY()
-    {
+    default double getY() {
         return getY(1f);
     }
 
     double getZ(float partialTick);
 
-    default double getZ()
-    {
+    default double getZ() {
         return getZ(1f);
     }
 
-    default Vec3 getPosition(float partialTick)
-    {
-        return Vec3.fromPool(getX(partialTick), getY(partialTick), getZ(partialTick));
+    default @NotNull TilePos getTilePos(float partialTick) {
+        return new TilePos(getX(partialTick), getY(partialTick), getZ(partialTick));
     }
 
-    default Vec3 getPosition()
-    {
+    default @NotNull TilePos getTilePos() {
+        return getTilePos(1f);
+    }
+
+    default @NotNull Vector3dc getPosition(float partialTick) {
+        return new Vector3d(getX(partialTick), getY(partialTick), getZ(partialTick));
+    }
+
+    default @NotNull Vector3dc getPosition() {
         return getPosition(1f);
     }
 
     double getXRot(float partialTick);
 
-    default double getXRot()
-    {
+    default double getXRot() {
         return getXRot(1f);
     }
 
     double getYRot(float partialTick);
 
-    default double getYRot()
-    {
+    default double getYRot() {
         return getYRot(1f);
     }
 
-    default Vec3 getViewVector(float partialTick)
-    {
-        float xRot = (float) getXRot(partialTick);
-        float yRot = (float) getYRot(partialTick);
-        float xzLen = -MathHelper.cos(-xRot * (MathHelper.PI / 180f));
-        float x = MathHelper.sin(-yRot * (MathHelper.PI / 180f) - MathHelper.PI);
-        float y = MathHelper.sin(-xRot * (MathHelper.PI / 180f));
-        float z = MathHelper.cos(-yRot * (MathHelper.PI / 180f) - MathHelper.PI);
-        return Vec3.fromPool(x * xzLen, y, z * xzLen);
-    }
-
-    default Vec3 getRotationVector(float partialTick)
-    {
-        double pitch = getXRot(partialTick);
-        double yaw = getYRot(partialTick);
-
-        double toRads = Math.PI / 180.0;
+    default @NotNull Vector3dc getViewVector(float partialTick) {
+        double pitch = Math.toRadians(getXRot(partialTick));
+        double yaw = Math.toRadians(getYRot(partialTick));
 
-        float xzLen = -MathHelper.cos((float) (-pitch * toRads));
-        float x = MathHelper.sin((float) (-yaw * toRads - Math.PI));
-        float y = MathHelper.sin((float) (-pitch * toRads));
-        float z = MathHelper.cos((float) (-yaw * toRads - Math.PI));
-        return Vec3.fromPool(x * xzLen, y, z * xzLen);
+        float xzLen = -MathHelper.cos((float) -pitch);
+        float x = MathHelper.sin((float) (-yaw - Math.PI));
+        float y = MathHelper.sin((float) -pitch);
+        float z = MathHelper.cos((float) (-yaw - Math.PI));
+        return new Vector3d(x * xzLen, y, z * xzLen);
     }
 
-    default Vec3 getRotationVector()
-    {
-        return getRotationVector(1f);
+    default @NotNull Vector3dc getViewVector() {
+        return getViewVector(1f);
     }
 
     double getFov();
 
-    CameraFrustum getFrustum();
+    @NotNull CameraFrustum getFrustum();
 
-    default double distanceToSqr(double x, double y, double z, float partialTick)
-    {
-        float dx = (float)(getX(partialTick) - x);
-        float dy = (float)(getY(partialTick) - y);
-        float dz = (float)(getZ(partialTick) - z);
+    default double distanceToSqr(double x, double y, double z, float partialTick) {
+        float dx = (float) (getX(partialTick) - x);
+        float dy = (float) (getY(partialTick) - y);
+        float dz = (float) (getZ(partialTick) - z);
         return dx * dx + dy * dy + dz * dz;
     }
 
-    default double distanceToSqr(double x, double y, double z)
-    {
+    default double distanceToSqr(double x, double y, double z) {
         return distanceToSqr(x, y, z, 1f);
     }
 
-    default double distanceTo(Entity entity, float partialTick)
-    {
+    default double distanceTo(@NotNull Entity entity, float partialTick) {
         return distanceTo(entity.x, entity.y, entity.z, partialTick);
     }
 
-    default double distanceTo(Entity entity)
-    {
+    default double distanceTo(@NotNull Entity entity) {
         return distanceTo(entity, 1f);
     }
 
-    default double distanceTo(double x, double y, double z, float partialTick)
-    {
+    default double distanceTo(double x, double y, double z, float partialTick) {
         return MathHelper.sqrt(distanceToSqr(x, y, z, partialTick));
     }
 
-    default double distanceTo(double x, double y, double z)
-    {
+    default double distanceTo(double x, double y, double z) {
         return distanceTo(x, y, z, 1f);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/colorizer/Colorizer.java b/game/client/src/main/java/net/minecraft/client/render/colorizer/Colorizer.java
index 7af3e56d2..0ec6906a1 100644
--- a/game/client/src/main/java/net/minecraft/client/render/colorizer/Colorizer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/colorizer/Colorizer.java
@@ -7,169 +7,168 @@ import net.minecraft.client.render.texturepack.TexturePack;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
 import net.minecraft.core.world.season.Season;
 import net.minecraft.core.world.season.Seasons;
 import net.minecraft.core.world.type.WorldType;
 import net.minecraft.core.world.type.WorldTypes;
+import org.jetbrains.annotations.NotNull;
 
 public class Colorizer {
-	
-	public final String name;
-	
-	private final ColorMap currentColor = new ColorMap();
-	private ColorMap defaultColor;
-	private TexturePack texturePack;
-	
-	public Colorizer(String name) {
-		this.name = name;
-	}
-	
-	public void setup(Minecraft minecraft, List<Season> seasons) {
-		texturePack = null;
-		if(minecraft.currentWorld == null) {
-			return;
-		}
-		
-		String path = null;
-
-		// First, check for worldtype overrides
-		WorldType worldType = minecraft.currentWorld.worldType;
-		if(worldType == WorldTypes.OVERWORLD_HELL) {
-			path = "/assets/minecraft/textures/colormap/" + this.name + "/hell.png";
-			texturePack = Colorizers.findTexturePackWithFile(minecraft, path);
-		}
-		if(worldType == WorldTypes.OVERWORLD_WINTER) {
-			path = "/assets/minecraft/textures/colormap/" + this.name + "/winter.png";
-			texturePack = Colorizers.findTexturePackWithFile(minecraft, path);
-		}
-		
-		if(texturePack == null) {
-			// Check if there is a colormap for the current dimension
-			Dimension dimension = minecraft.currentWorld.dimension;
-			String dimensionName = dimension.languageKey.replace('.', '_').toLowerCase();
-			path = "/assets/minecraft/textures/colormap/" + this.name + "/" + dimensionName + ".png";
-			texturePack = Colorizers.findTexturePackWithFile(minecraft, path);	
-		}
-		
-		
-		if(texturePack == null) {
-			// If there is no colormap for the currrent dimension, check if there is a default colormap, to be used for all dimensions
-			path = "/assets/minecraft/textures/colormap/" + this.name + "/default.png";
-			texturePack = Colorizers.findTexturePackWithFile(minecraft, path);
-		}
-		
-		// If there is no default colormap, disable the colorizer
-		if(path == null || texturePack == null) {
-			texturePack = null;
-			return;
-		}
-		
-		// Actually load the colormap
-		this.defaultColor = Colorizers.loadColorData(texturePack, path);
-		if(defaultColor == null) {
-			// If a colormap is found by the first code, but it can't get loaded, throw an Exception
-			throw new NullPointerException("Could not load colormap '" + path + "' from asset pack '" + texturePack.fileName + "'!");
-		}
-	}
-	
-	public ColorMap loadColormap(Dimension dimension, Season season) {
-		if(season == null || season == Seasons.NULL) {
-			return defaultColor;
-		}
-		
-		String seasonName = season.getId().replace('.', '_').toLowerCase();
-		String seasonPath = "/assets/minecraft/textures/colormap/" + this.name + "/" + seasonName + ".png";
-		
-		ColorMap seasonColor = Colorizers.loadColorData(texturePack, seasonPath);
-		if(seasonColor != null) {
-			return seasonColor;
-		}
-		
-		return defaultColor;
-	}
-	
-	public void update(Dimension dimension, Season season1, Season season2, float blendFactor) {
-		if(!isEnabled()) {
-			return;
-		}
-		
-		ColorMap colorMap1 = loadColormap(dimension, season1);
-		ColorMap colorMap2 = loadColormap(dimension, season2);
-		
-		if(colorMap1 == colorMap2) {
-			update(colorMap1);
-		}else {
-			update(colorMap1, colorMap2, blendFactor);	
-		}
-	}
-	
-	public void update(ColorMap colorMap) {
-		for(int i=0; i < currentColor.buffer.length; i++) {
-			currentColor.buffer[i] = colorMap.buffer[i];
-		}
-	}
-	
-	public void update(ColorMap colorMap1, ColorMap colorMap2, float blendFactor) {
-		for(int i=0; i < currentColor.buffer.length; i++) {
-			currentColor.buffer[i] = blendColor(colorMap1.buffer[i], colorMap2.buffer[i], blendFactor);
-		}
-	}
-	
-	public int getDefaultColor(double temperature, double humidity) {
-		if(!isEnabled()) {
-			return 0xFFFFFFFF;
-		}
-		
-		return defaultColor.getColor(temperature, humidity);
-	}
-	
-	public int getColor(WorldSource world, int x, int y, int z) {
-		if(!isEnabled()) {
-			return 0xFFFFFFFF;
-		}
-		
-		double temperature = world.getBlockTemperature(x, z);
-		double humidity = world.getBlockHumidity(x, z);
-		
-		return getColor(temperature, humidity);
-	}
-	
-	public int getColor(double temperature, double humidity) {
-		if(!isEnabled()) {
-			return 0xFFFFFFFF;
-		}
-		
-		return currentColor.getColor(temperature, humidity);
-	}
-	
-	public boolean isEnabled() {
-		return texturePack != null;
-	}
-	
-	public TexturePack getTexturePack() {
-		return texturePack;
-	}
-	
-	public static int blendColor(int color1, int color2, float blend) {
-		float blend1 = 1.0f - blend;
-		
-		int r1 = (color1 >> 16) & 0xFF;
-		int g1 = (color1 >>  8) & 0xFF;
-		int b1 = (color1 >>  0) & 0xFF;
-		
-		int r2 = (color2 >> 16) & 0xFF;
-		int g2 = (color2 >>  8) & 0xFF;
-		int b2 = (color2 >>  0) & 0xFF;
-		
-		int r = (int)(r1 * blend1 + r2 * blend);
-		int g = (int)(g1 * blend1 + g2 * blend);
-		int b = (int)(b1 * blend1 + b2 * blend);
-		
-		r = MathHelper.clamp(r, 0, 255);
-		g = MathHelper.clamp(g, 0, 255);
-		b = MathHelper.clamp(b, 0, 255);
-		
-		return r << 16 | g << 8 | b; 
-	}
+
+    public final String name;
+
+    private final ColorMap currentColor = new ColorMap();
+    private ColorMap defaultColor;
+    private TexturePack texturePack;
+
+    public Colorizer(String name) {
+        this.name = name;
+    }
+
+    public void setup(@NotNull Minecraft minecraft, List<Season> seasons) {
+        this.texturePack = null;
+        if (minecraft.currentWorld == null) {
+            return;
+        }
+
+        String path = null;
+
+        // First, check for worldtype overrides
+        WorldType worldType = minecraft.currentWorld.worldType;
+        if (worldType == WorldTypes.OVERWORLD_HELL) {
+            path = "/assets/minecraft/textures/colormap/" + this.name + "/hell.png";
+            this.texturePack = Colorizers.findTexturePackWithFile(minecraft, path);
+        }
+        if (worldType == WorldTypes.OVERWORLD_WINTER) {
+            path = "/assets/minecraft/textures/colormap/" + this.name + "/winter.png";
+            this.texturePack = Colorizers.findTexturePackWithFile(minecraft, path);
+        }
+
+        if (this.texturePack == null) {
+            // Check if there is a colormap for the current dimension
+            Dimension dimension = minecraft.currentWorld.dimension;
+            String dimensionName = dimension.languageKey.replace('.', '_').toLowerCase();
+            path = "/assets/minecraft/textures/colormap/" + this.name + "/" + dimensionName + ".png";
+            this.texturePack = Colorizers.findTexturePackWithFile(minecraft, path);
+        }
+
+
+        if (this.texturePack == null) {
+            // If there is no colormap for the currrent dimension, check if there is a default colormap, to be used for all dimensions
+            path = "/assets/minecraft/textures/colormap/" + this.name + "/default.png";
+            this.texturePack = Colorizers.findTexturePackWithFile(minecraft, path);
+        }
+
+        // If there is no default colormap, disable the colorizer
+        if (this.texturePack == null) {
+            return;
+        }
+
+        // Actually load the colormap
+        this.defaultColor = Colorizers.loadColorData(this.texturePack, path);
+        if (this.defaultColor == null) {
+            // If a colormap is found by the first code, but it can't get loaded, throw an Exception
+            throw new NullPointerException("Could not load colormap '" + path + "' from asset pack '" + this.texturePack.fileName + "'!");
+        }
+    }
+
+    public ColorMap loadColormap(Dimension dimension, Season season) {
+        if (season == null || season == Seasons.NULL) {
+            return this.defaultColor;
+        }
+
+        String seasonName = season.getId().replace('.', '_').toLowerCase();
+        String seasonPath = "/assets/minecraft/textures/colormap/" + this.name + "/" + seasonName + ".png";
+
+        ColorMap seasonColor = Colorizers.loadColorData(this.texturePack, seasonPath);
+        if (seasonColor != null) {
+            return seasonColor;
+        }
+
+        return this.defaultColor;
+    }
+
+    public void update(Dimension dimension, Season season1, Season season2, float blendFactor) {
+        if (!isEnabled()) {
+            return;
+        }
+
+        ColorMap colorMap1 = loadColormap(dimension, season1);
+        ColorMap colorMap2 = loadColormap(dimension, season2);
+
+        if (colorMap1 == colorMap2) {
+            update(colorMap1);
+        } else {
+            update(colorMap1, colorMap2, blendFactor);
+        }
+    }
+
+    public void update(ColorMap colorMap) {
+        System.arraycopy(colorMap.buffer, 0, this.currentColor.buffer, 0, this.currentColor.buffer.length);
+    }
+
+    public void update(ColorMap colorMap1, ColorMap colorMap2, float blendFactor) {
+        for (int i = 0; i < this.currentColor.buffer.length; i++) {
+            this.currentColor.buffer[i] = blendColor(colorMap1.buffer[i], colorMap2.buffer[i], blendFactor);
+        }
+    }
+
+    public int getDefaultColor(double temperature, double humidity) {
+        if (!isEnabled()) {
+            return 0xFFFFFFFF;
+        }
+
+        return this.defaultColor.getColor(temperature, humidity);
+    }
+
+    public int getColor(WorldSource world, @NotNull TilePosc tilePos) {
+        if (!isEnabled()) {
+            return 0xFFFFFFFF;
+        }
+
+        double temperature = world.getBlockTemperature(tilePos);
+        double humidity = world.getBlockHumidity(tilePos);
+
+        return getColor(temperature, humidity);
+    }
+
+    public int getColor(double temperature, double humidity) {
+        if (!isEnabled()) {
+            return 0xFFFFFFFF;
+        }
+
+        return this.currentColor.getColor(temperature, humidity);
+    }
+
+    public boolean isEnabled() {
+        return this.texturePack != null;
+    }
+
+    public TexturePack getTexturePack() {
+        return this.texturePack;
+    }
+
+    public static int blendColor(int color1, int color2, float blend) {
+        float blend1 = 1.0f - blend;
+
+        int r1 = (color1 >> 16) & 0xFF;
+        int g1 = (color1 >> 8) & 0xFF;
+        int b1 = (color1 >> 0) & 0xFF;
+
+        int r2 = (color2 >> 16) & 0xFF;
+        int g2 = (color2 >> 8) & 0xFF;
+        int b2 = (color2 >> 0) & 0xFF;
+
+        int r = (int) (r1 * blend1 + r2 * blend);
+        int g = (int) (g1 * blend1 + g2 * blend);
+        int b = (int) (b1 * blend1 + b2 * blend);
+
+        r = MathHelper.clamp(r, 0, 255);
+        g = MathHelper.clamp(g, 0, 255);
+        b = MathHelper.clamp(b, 0, 255);
+
+        return r << 16 | g << 8 | b;
+    }
 
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/culling/CameraFrustum.java b/game/client/src/main/java/net/minecraft/client/render/culling/CameraFrustum.java
index d27fc773e..e580aa5d3 100644
--- a/game/client/src/main/java/net/minecraft/client/render/culling/CameraFrustum.java
+++ b/game/client/src/main/java/net/minecraft/client/render/culling/CameraFrustum.java
@@ -1,34 +1,29 @@
 package net.minecraft.client.render.culling;
 
 import net.minecraft.client.render.camera.ICamera;
-import net.minecraft.client.render.culling.FrustumData;
-import net.minecraft.client.render.culling.Frustum;
-import net.minecraft.core.util.phys.AABB;
+import org.jetbrains.annotations.NotNull;
+import org.joml.primitives.AABBdc;
 
-public class CameraFrustum
-{
-    private final ICamera camera;
-    private final FrustumData frustum;
+public class CameraFrustum {
+    private final @NotNull ICamera camera;
+    private final @NotNull FrustumData frustum;
 
-    public CameraFrustum(ICamera camera)
-    {
+    public CameraFrustum(@NotNull ICamera camera) {
         this.camera = camera;
         this.frustum = Frustum.getFrustum();
     }
 
-    public boolean cubeInFrustum(double x0, double y0, double z0, double x1, double y1, double z1, float partialTick)
-    {
-        return this.frustum.cubeInFrustum(x0 - camera.getX(partialTick),
-                                                  y0 - camera.getY(partialTick),
-                                                  z0 - camera.getZ(partialTick),
-                                                  x1 - camera.getX(partialTick),
-                                                  y1 - camera.getY(partialTick),
-                                                  z1 - camera.getZ(partialTick)
+    public boolean cubeInFrustum(double x0, double y0, double z0, double x1, double y1, double z1, float partialTick) {
+        return this.frustum.cubeInFrustum(x0 - this.camera.getX(partialTick),
+            y0 - this.camera.getY(partialTick),
+            z0 - this.camera.getZ(partialTick),
+            x1 - this.camera.getX(partialTick),
+            y1 - this.camera.getY(partialTick),
+            z1 - this.camera.getZ(partialTick)
         );
     }
 
-    public boolean isVisible(AABB aabb, float partialTick)
-    {
-        return cubeInFrustum(aabb.minX, aabb.minY, aabb.minZ, aabb.maxX, aabb.maxY, aabb.maxZ, partialTick);
+    public boolean isVisible(@NotNull AABBdc aabb, float partialTick) {
+        return cubeInFrustum(aabb.minX(), aabb.minY(), aabb.minZ(), aabb.maxX(), aabb.maxY(), aabb.maxZ(), partialTick);
     }
 }
